diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-mlo-test.cc ns-3.45/src/wifi/test/wifi-mlo-test.cc
--- ns-3.44/src/wifi/test/wifi-mlo-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-mlo-test.cc	2025-06-01 20:34:45.639702300 -0700
@@ -3063,8 +3326,10 @@
           ParamsTuple(
               {{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
                {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-               {0, 1}},
+               {0, 1},
+               WifiAssocType::ML_SETUP},
               {0, 1},
+              {}, // IDs of setup links are the same for AP and non-AP devices
               WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
               "0,1,2,3  1",
               "0,1,2,3  1"),
@@ -3075,8 +3340,10 @@
           // hence 2 links are setup by switching channel (not band) on the third link
           ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{60, 0, BAND_5GHZ, 0}"},
                        {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                       {0, 1, 2}},
+                       {0, 1, 2},
+                       WifiAssocType::ML_SETUP},
                       {0, 2},
+                      {}, // IDs of setup links are the same for AP and non-AP devices
                       WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
                       "",
                       ""),
@@ -3085,32 +3352,70 @@
           // an AP operating on the same channel; hence one link only is setup
           ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
                        {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                       {0, 1}},
+                       {0, 1},
+                       WifiAssocType::ML_SETUP},
                       {2},
+                      {}, // IDs of setup links are the same for AP and non-AP devices
                       WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
                       "",
                       ""),
           // non-AP MLD has only two STAs and setups two links
           ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
                        {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                       {}},
+                       {},
+                       WifiAssocType::ML_SETUP},
                       {1, 0},
+                      {}, // IDs of setup links are the same for AP and non-AP devices
                       WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
                       "0,1,2,3  1",
                       ""),
-          // single link non-AP STA associates with an AP affiliated with an AP MLD
+          // AP MLD and non-AP MLD setup only one link using legacy association
+          ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{60, 0, BAND_5GHZ, 0}"},
+                       {"{120, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
+                       {},
+                       WifiAssocType::LEGACY},
+                      {2},
+                      {1},
+                      WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
+                      "",
+                      ""),
+          // single link non-AP STA performs legacy association with an AP affiliated with an AP MLD
           ParamsTuple({{"{120, 0, BAND_5GHZ, 0}"},
                        {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                       {}},
-                      {2}, // link ID of AP MLD only (non-AP STA is single link)
+                       {},
+                       WifiAssocType::LEGACY},
+                      {2},
+                      {0}, // non-AP STA performs legacy association
                       WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
                       "",
                       ""),
-          // a STA affiliated with a non-AP MLD associates with a single link AP
+          // single link non-AP STA performs ML setup with an AP affiliated with an AP MLD
+          ParamsTuple({{"{120, 0, BAND_5GHZ, 0}"},
+                       {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {},
+                       WifiAssocType::ML_SETUP},
+                      {2},
+                      {2}, // IDs of setup links are the same for AP and non-AP devices
+                      WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
+                      "",
+                      ""),
+          // a STA affiliated with a non-AP MLD performs legacy association with a single link AP
+          ParamsTuple({{"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {"{120, 0, BAND_5GHZ, 0}"},
+                       {},
+                       WifiAssocType::LEGACY},
+                      {0}, // AP is single link
+                      {2},
+                      WifiTidToLinkMappingNegSupport::NOT_SUPPORTED,
+                      "0,1,2,3  0,1;  4,5,6,7  0,1", // ignored by single link AP
+                      ""),
+          // a STA affiliated with a non-AP MLD performs ML setup with a single link AP
           ParamsTuple({{"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
                        {"{120, 0, BAND_5GHZ, 0}"},
-                       {}},
-                      {2}, // link ID of non-AP MLD only (AP is single link)
+                       {},
+                       WifiAssocType::ML_SETUP},
+                      {0}, // AP is single link
+                      {2}, // legacy association is performed anyway because AP is single link
                       WifiTidToLinkMappingNegSupport::NOT_SUPPORTED,
                       "0,1,2,3  0,1;  4,5,6,7  0,1", // ignored by single link AP
                       "")})
@@ -3118,6 +3423,7 @@
         AddTestCase(new MultiLinkSetupTest(baseParams,
                                            WifiScanType::PASSIVE,
                                            setupLinks,
+                                           staSetupLinks,
                                            apNegSupport,
                                            dlTidLinkMapping,
                                            ulTidLinkMapping),
@@ -3125,6 +3431,7 @@
         AddTestCase(new MultiLinkSetupTest(baseParams,
                                            WifiScanType::ACTIVE,
                                            setupLinks,
+                                           staSetupLinks,
                                            apNegSupport,
                                            dlTidLinkMapping,
                                            ulTidLinkMapping),
@@ -3185,6 +3492,8 @@
 
     AddTestCase(new ReleaseSeqNoAfterCtsTimeoutTest(), TestCase::Duration::QUICK);
     AddTestCase(new StartSeqNoUpdateAfterAddBaTimeoutTest(), TestCase::Duration::QUICK);
+    AddTestCase(new BarAfterDroppedMpduTest(WifiAssocType::ML_SETUP), TestCase::Duration::QUICK);
+    AddTestCase(new BarAfterDroppedMpduTest(WifiAssocType::LEGACY), TestCase::Duration::QUICK);
 }
 
 static WifiMultiLinkOperationsTestSuite g_wifiMultiLinkOperationsTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-mlo-test.h ns-3.45/src/wifi/test/wifi-mlo-test.h
--- ns-3.44/src/wifi/test/wifi-mlo-test.h	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-mlo-test.h	2025-06-01 20:34:45.639702300 -0700
@@ -149,8 +149,9 @@
      * Constructor.
      *
      * @param linkIds A vector specifying the set of link IDs each STA will setup
+     * @param assocType the type of association procedure for non-AP devices
      */
-    AidAssignmentTest(const std::vector<std::set<uint8_t>>& linkIds);
+    AidAssignmentTest(const std::vector<std::set<uint8_t>>& linkIds, WifiAssocType assocType);
 
   private:
     void DoSetup() override;
@@ -166,7 +167,9 @@
 
     const std::vector<std::string> m_linkChannels;  //!< channels for all AP links
     const std::vector<std::set<uint8_t>> m_linkIds; //!< link IDs for all non-AP STAs/MLDs
+    WifiAssocType m_assocType;                      //!< association type
     NetDeviceContainer m_staDevices;                //!< non-AP STAs/MLDs devices
+    uint16_t m_startAid;                            //!< first AID to allocate to stations
     uint16_t m_expectedAid;                         //!< expected AID for current non-AP STA/MLD
 };
 
@@ -193,7 +196,8 @@
         std::vector<std::string>
             apChannels; //!< the strings specifying the operating channels for the AP MLD
         std::vector<uint8_t>
-            fixedPhyBands; //!< list of IDs of non-AP MLD PHYs that cannot switch band
+            fixedPhyBands;         //!< list of IDs of non-AP MLD PHYs that cannot switch band
+        WifiAssocType assocType{}; //!< type of the association procedure used by non-AP devices
     };
 
     /**
@@ -295,13 +299,15 @@
     const std::vector<std::string> m_staChannels; ///< strings specifying channels for STA
     const std::vector<std::string> m_apChannels;  ///< strings specifying channels for AP
     const std::vector<uint8_t> m_fixedPhyBands;   ///< links on non-AP MLD with fixed PHY band
-    Ptr<ApWifiMac> m_apMac;                       ///< AP wifi MAC
-    std::vector<Ptr<StaWifiMac>> m_staMacs;       ///< STA wifi MACs
-    uint8_t m_nStations;                          ///< number of stations to create
-    uint16_t m_lastAid;                           ///< AID of last associated station
-    Time m_duration{Seconds(1)};                  ///< simulation duration
-    std::vector<std::size_t> m_rxPkts; ///< number of packets received at application layer
-                                       ///< by each node (index is node ID)
+    WifiAssocType m_assocType; ///< type of the association procedure used by non-AP devices
+    Ptr<ApWifiMac> m_apMac;    ///< AP wifi MAC
+    std::vector<Ptr<StaWifiMac>> m_staMacs; ///< STA wifi MACs
+    uint8_t m_nStations;                    ///< number of stations to create
+    uint16_t m_startAid;                    ///< first AID to allocate to stations
+    uint16_t m_lastAid;                     ///< AID of last associated station
+    Time m_duration{Seconds(1)};            ///< simulation duration
+    std::vector<std::size_t> m_rxPkts;      ///< number of packets received at application layer
+                                            ///< by each node (index is node ID)
 
     /**
      * Reset the given PHY helper, use the given strings to set the ChannelSettings
@@ -372,8 +378,11 @@
      *
      * @param baseParams common configuration parameters
      * @param scanType the scan type (active or passive)
-     * @param setupLinks a list of links that are expected to be setup. In case one of the two
-     *                   devices has a single link, the ID of the link on the MLD is indicated
+     * @param setupLinks a list of IDs (as seen by the AP device) of the links that are expected
+     *                   to be setup
+     * @param staSetupLinks a list of IDs (as seen by the non-AP device) of the links that are
+     *                      expected to be setup. This list shall be left empty (indicating that
+     *                      it equals the setupLinks argument) when ML setup is performed
      * @param apNegSupport TID-to-Link Mapping negotiation supported by the AP MLD (0, 1, or 3)
      * @param dlTidToLinkMapping DL TID-to-Link Mapping for EHT configuration of non-AP MLD
      * @param ulTidToLinkMapping UL TID-to-Link Mapping for EHT configuration of non-AP MLD
@@ -382,6 +391,7 @@
     MultiLinkSetupTest(const BaseParams& baseParams,
                        WifiScanType scanType,
                        const std::vector<uint8_t>& setupLinks,
+                       const std::vector<uint8_t>& staSetupLinks,
                        WifiTidToLinkMappingNegSupport apNegSupport,
                        const std::string& dlTidToLinkMapping,
                        const std::string& ulTidToLinkMapping,
@@ -453,8 +463,11 @@
                       uint8_t linkId,
                       std::size_t index);
 
-    const std::vector<uint8_t> m_setupLinks; //!< IDs of the expected links to setup
-    WifiScanType m_scanType;                 //!< the scan type (active or passive)
+    const std::vector<uint8_t> m_setupLinks;    //!< IDs (as seen by the AP device) of the expected
+                                                //!< links to setup
+    const std::vector<uint8_t> m_staSetupLinks; //!< IDs (as seen by the non-AP device) of the
+                                                //!< expected links to setup
+    WifiScanType m_scanType;                    //!< the scan type (active or passive)
     std::size_t m_nProbeResp; //!< number of Probe Responses received by the non-AP MLD
     WifiTidToLinkMappingNegSupport
         m_apNegSupport;                //!< TID-to-Link Mapping negotiation supported by the AP MLD
@@ -776,6 +789,73 @@
 };
 
 /**
+ * @ingroup wifi-test
+ * @ingroup tests
+ *
+ * @brief Test BlockAckReq frame sent by a Block Ack originator after dropping QoS data frames
+ *
+ * In this test, a non-AP STA associates with an AP MLD with 2 links using either legacy association
+ * or ML setup. A Block Ack agreement is established first in the downlink direction; the AP MLD
+ * sends 2 data frames, which are both corrupted. When a timeout occurs at the AP MLD, the 2 data
+ * frames are dropped, thus the AP MLD sends a BlockAckReq to advance the recipient window. It is
+ * checked that the BlockAckReq has the correct link addresses and that the non-AP STA replies with
+ * a BlockAck having correct link addresses. Then, a Block Ack agreement is established in the
+ * uplink direction and the same pattern of actions are repeated (in the inverse direction).
+ */
+class BarAfterDroppedMpduTest : public MultiLinkOperationsTestBase
+{
+  public:
+    /**
+     * Constructor.
+     *
+     * @param assocType the association type
+     */
+    BarAfterDroppedMpduTest(WifiAssocType assocType);
+
+  protected:
+    void DoSetup() override;
+    void DoRun() override;
+    void Transmit(Ptr<WifiMac> mac,
+                  uint8_t phyId,
+                  WifiConstPsduMap psduMap,
+                  WifiTxVector txVector,
+                  double txPowerW) override;
+
+    /// Actions and checks to perform upon the transmission of each frame
+    struct Events
+    {
+        /**
+         * Constructor.
+         *
+         * @param type the frame MAC header type
+         * @param f function to perform actions and checks
+         */
+        Events(WifiMacType type,
+               std::function<void(Ptr<const WifiPsdu>, const WifiTxVector&, uint8_t)>&& f = {})
+            : hdrType(type),
+              func(f)
+        {
+        }
+
+        WifiMacType hdrType; ///< MAC header type of frame being transmitted
+        std::function<void(Ptr<const WifiPsdu>, const WifiTxVector&, uint8_t)>
+            func; ///< function to perform actions and checks
+    };
+
+    /// Insert elements in the list of expected events (transmitted frames)
+    void InsertEvents();
+
+  private:
+    void StartTraffic() override;
+
+    bool m_setupDone{false};             //!< whether association has been completed
+    std::list<Events> m_events;          //!< list of events for a test run
+    std::size_t m_processedEvents{0};    //!< number of processed events
+    Ptr<ListErrorModel> m_staErrorModel; //!< error rate model to corrupt frames at the non-AP STA
+    Ptr<ListErrorModel> m_apErrorModel;  //!< error rate model to corrupt frames at the AP MLD
+};
+
+/**
  * @ingroup wifi-test
  * @ingroup tests
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-non-ht-dup-test.cc ns-3.45/src/wifi/test/wifi-non-ht-dup-test.cc
--- ns-3.44/src/wifi/test/wifi-non-ht-dup-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-non-ht-dup-test.cc	2025-06-01 20:34:45.639702300 -0700
@@ -65,7 +65,9 @@
      * @param muRtsTxVector the TXVECTOR used to transmit MU-RTS trigger frame
      */
     void SetMuRtsTxVector(const WifiTxVector& muRtsTxVector);
-}; // class MuRtsCtsHePhy
+
+    // end of class MuRtsCtsHePhy
+};
 
 MuRtsCtsHePhy::MuRtsCtsHePhy()
     : HePhy()
@@ -126,7 +128,9 @@
 
   private:
     Ptr<MuRtsCtsHePhy> m_muRtsCtsHePhy; ///< Pointer to HE PHY instance used for MU-RTS/CTS PHY test
-};                                      // class MuRtsCtsSpectrumWifiPhy
+
+    // end of class MuRtsCtsSpectrumWifiPhy
+};
 
 TypeId
 MuRtsCtsSpectrumWifiPhy::GetTypeId()
@@ -335,16 +339,9 @@
                                          channelWidth,
                                          false);
 
-    Ptr<Packet> pkt = Create<Packet>(1000);
+    auto pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
-
-    hdr.SetType(WIFI_MAC_QOSDATA);
-    hdr.SetQosTid(0);
-
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
-    Time txDuration =
-        SpectrumWifiPhy::CalculateTxDuration(psdu->GetSize(), txVector, m_phyAp->GetPhyBand());
-
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
     m_phyAp->Send(WifiConstPsduMap({std::make_pair(SU_STA_ID, psdu)}), txVector);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-operating-channel-test.cc ns-3.45/src/wifi/test/wifi-operating-channel-test.cc
--- ns-3.44/src/wifi/test/wifi-operating-channel-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-operating-channel-test.cc	2025-06-01 20:34:45.639702300 -0700
@@ -220,6 +220,14 @@
            WIFI_STANDARD_UNSPECIFIED,
            WIFI_PHY_BAND_UNSPECIFIED,
            true);
+
+    RunOne("default 320 MHz OFDM channel operating on channel 31",
+           {{31, 0, 320, WIFI_PHY_BAND_6GHZ}},
+           WIFI_STANDARD_UNSPECIFIED,
+           WIFI_PHY_BAND_UNSPECIFIED,
+           false,
+           WifiChannelWidthType::CW_320MHZ,
+           {{31, 6105, 320, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM}});
 }
 
 /**
@@ -275,7 +283,7 @@
     m_phy->SetErrorRateModel(error);
     m_phy->SetDevice(dev);
     m_phy->AddChannel(spectrumChannel);
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211be);
     dev->SetPhy(m_phy);
     node->AddDevice(dev);
 }
@@ -416,6 +424,13 @@
            {{50, MHz_u{5250}, MHz_u{160}, WIFI_PHY_BAND_5GHZ}},
            0);
 
+    // Test unique channel 31 (320 MHz)
+    // TODO: logic should be changed to support passing BAND_UNSPECIFIED
+    RunOne("{31, 0, BAND_6GHZ, 0}",
+           WifiChannelWidthType::CW_320MHZ,
+           {{31, 6105, 320, WIFI_PHY_BAND_6GHZ}},
+           0);
+
     // Test 80+80 MHz
     RunOne("{42, 0, BAND_UNSPECIFIED, 0};{106, 0, BAND_UNSPECIFIED, 0}",
            WifiChannelWidthType::CW_80_PLUS_80MHZ,
@@ -460,6 +475,13 @@
            {{42, MHz_u{5210}, MHz_u{80}, WIFI_PHY_BAND_5GHZ},
             {106, MHz_u{5530}, MHz_u{80}, WIFI_PHY_BAND_5GHZ}},
            0);
+
+    // Test default 320 MHz channel
+    // TODO: logic should be changed to support passing BAND_UNSPECIFIED
+    RunOne("{0, 320, BAND_6GHZ, 0}",
+           WifiChannelWidthType::CW_320MHZ,
+           {{31, 6105, 320, WIFI_PHY_BAND_6GHZ}},
+           0);
 }
 
 /**
